﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

//
// SketchFlow は、どのコントロール アセンブリがスクリーンを含んでいるのかを判断する必要があります。これは自動的にプロジェクト作成で設定されますが、
// コントロール アセンブリ名を手動で変更した場合、
// ここで手動で更新する必要があります。
//
[assembly: Microsoft.Expression.Prototyping.Services.SketchFlowLibraries("TravelPlanner.Screens")]

namespace TravelPlanner
{
	public partial class App : Application
	{
		public App()
		{
			this.Startup += this.Application_Startup;
			this.Exit += this.Application_Exit;
			this.UnhandledException += this.Application_UnhandledException;

			InitializeComponent();
		}

		private void Application_Startup(object sender, StartupEventArgs e)
		{
			this.RootVisual = new Microsoft.Expression.Prototyping.Workspace.PlayerWindow();
		}

		private void Application_Exit(object sender, EventArgs e)
		{
		}

		private void Application_UnhandledException(object sender, ApplicationUnhandledExceptionEventArgs e)
		{
			// アプリケーションがデバッガーの外側で実行されている場合、
			// ブラウザーの例外機能を使用して例外が報告されます。これにより、IE ではステータス バーに 
			// 黄色の通知アイコンが表示され、Firefox にはスクリプト エラーが表示されます。
			if (!System.Diagnostics.Debugger.IsAttached)
			{

				// メモ: これにより、例外がスローされたが処理されなかった場合でも、
				// アプリケーションは実行を維持できます。
				// 実稼働アプリケーションでは、このエラー処理は、
				// Web サイトにエラーを報告し、アプリケーションを停止する機能に置換える必要があります。
				e.Handled = true;
				Deployment.Current.Dispatcher.BeginInvoke(delegate { ReportErrorToDOM(e); });
			}
		}

		private void ReportErrorToDOM(ApplicationUnhandledExceptionEventArgs e)
		{
			try
			{
				string errorMsg = e.ExceptionObject.Message + e.ExceptionObject.StackTrace;
				errorMsg = errorMsg.Replace('"', '\'').Replace("\r\n", @"\n");

				System.Windows.Browser.HtmlPage.Window.Eval("throw new Error(\"Unhandled Error in Silverlight Application " + errorMsg + "\");");
			}
			catch (Exception)
			{
			}
		}
	}
}